diff -u -r1.20 tracker.inc.php
--- tracker.inc.php	3 Dec 2003 12:36:02 -0000	1.20
+++ tracker.inc.php	7 May 2004 11:46:06 -0000
@@ -658,7 +658,7 @@
 			}
 		}
 		// ڡȼ
-		$this->rows = array();
+		$this->get_cache_rows();
 		$pattern = "$page/";
 		$pattern_len = strlen($pattern);
 		foreach (get_existpages() as $_page)
@@ -673,6 +673,62 @@
 				$this->add($_page,$name);
 			}
 		}
+		$this->put_cache_rows();
+	}
+	function get_cache_rows()
+	{
+		$this->rows = array();
+		
+		$filename = CACHE_DIR.encode($this->page).'.tracker';
+		if (!file_exists($filename))
+		{
+			return;
+		}
+		$fp = fopen($filename,'r')
+			or die('cannot open '.$filename);
+		set_file_buffer($fp, 0);
+		flock($fp,LOCK_EX);
+		rewind($fp);
+		while ($arr = fgetcsv($fp, 4096))
+		{
+			$row = array();
+			foreach (array_keys($this->fields) as $field)
+			{
+				$row[$field] = array_shift($arr);
+			}
+			if (get_filetime($this->page.'/'.$row['_real']) == $row['_update'])
+			{
+				$this->rows[$row['_real']] = $row;
+			}
+		}
+		flock($fp,LOCK_UN);
+		fclose($fp);
+	}
+	function put_cache_rows()
+	{
+		ksort($this->rows);
+		
+		$filename = CACHE_DIR.encode($this->page).'.tracker';
+		if (!$fp = fopen($filename,'r+'))
+		{
+			$fp = fopen($filename, 'w')
+				or die('cannot open '.$filename);
+		}
+		set_file_buffer($fp, 0);
+		flock($fp, LOCK_EX);
+		rewind($fp);
+		ftruncate($fp);
+		foreach ($this->rows as $row)
+		{
+			$arr = array();
+			foreach (array_keys($this->fields) as $key)
+			{
+				$arr[$key] = $row[$key];
+			}
+			fputs($fp, csv_implode(',', $arr)."\n");
+		}
+		flock($fp, LOCK_UN);
+		fclose($fp);
 	}
 	function add($page,$name)
 	{
